From 4377a9e8379fe45b4404700ecd93e7dd3eb3c0c8 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:12 +0000
Subject: [PATCH 403/2232] Rename Type::Vector to CxxVector


---

diff --git a/gen/write.rs b/gen/write.rs
index 6c43928..deae886 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -125,7 +125,7 @@ fn write_includes(out: &mut OutFile, types: &Types) {
             },
             Type::RustBox(_) => out.include.type_traits = true,
             Type::UniquePtr(_) => out.include.memory = true,
-            Type::Vector(_) => out.include.vector = true,
+            Type::CxxVector(_) => out.include.vector = true,
             Type::SliceRefU8(_) => out.include.cstdint = true,
             _ => {}
         }
@@ -478,7 +478,7 @@ fn write_cxx_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
     match &efn.ret {
         Some(Type::RustBox(_)) => write!(out, ".into_raw()"),
         Some(Type::UniquePtr(_)) => write!(out, ".release()"),
-        Some(Type::Vector(_)) => write!(
+        Some(Type::CxxVector(_)) => write!(
             out,
             " /* Use RVO to convert to r-value and move construct */"
         ),
@@ -792,7 +792,7 @@ fn write_extern_return_type_space(out: &mut OutFile, ty: &Option<Type>, types: &
 
 fn write_extern_arg(out: &mut OutFile, arg: &Var, types: &Types) {
     match &arg.ty {
-        Type::RustBox(ty) | Type::UniquePtr(ty) | Type::Vector(ty) => {
+        Type::RustBox(ty) | Type::UniquePtr(ty) | Type::CxxVector(ty) => {
             write_type_space(out, &ty.inner);
             write!(out, "*");
         }
@@ -827,7 +827,7 @@ fn write_type(out: &mut OutFile, ty: &Type) {
             write_type(out, &ptr.inner);
             write!(out, ">");
         }
-        Type::Vector(ty) => {
+        Type::CxxVector(ty) => {
             write!(out, "::std::vector<");
             write_type(out, &ty.inner);
             write!(out, ">");
@@ -879,7 +879,7 @@ fn write_space_after_type(out: &mut OutFile, ty: &Type) {
         | Type::RustBox(_)
         | Type::UniquePtr(_)
         | Type::Str(_)
-        | Type::Vector(_)
+        | Type::CxxVector(_)
         | Type::RustVec(_)
         | Type::SliceRefU8(_)
         | Type::Fn(_) => write!(out, " "),
@@ -916,7 +916,7 @@ fn write_generic_instantiations(out: &mut OutFile, types: &Types) {
                     out.next_section();
                     write_unique_ptr(out, &ptr.inner, types);
                 }
-            } else if let Type::Vector(ptr1) = &ptr.inner {
+            } else if let Type::CxxVector(ptr1) = &ptr.inner {
                 if let Type::Ident(inner) = &ptr1.inner {
                     if allow_vector(inner) {
                         out.next_section();
@@ -924,7 +924,7 @@ fn write_generic_instantiations(out: &mut OutFile, types: &Types) {
                     }
                 }
             }
-        } else if let Type::Vector(ptr) = ty {
+        } else if let Type::CxxVector(ptr) = ty {
             if let Type::Ident(inner) = &ptr.inner {
                 if allow_vector(inner) {
                     out.next_section();
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 1966d7a..9b17b11 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -64,7 +64,7 @@ pub fn bridge(namespace: &Namespace, ffi: ItemMod) -> Result<TokenStream> {
                 if Atom::from(ident).is_none() {
                     expanded.extend(expand_unique_ptr(namespace, &ptr.inner, types));
                 }
-            } else if let Type::Vector(_) = &ptr.inner {
+            } else if let Type::CxxVector(_) = &ptr.inner {
                 // Generate code for unique_ptr<vector<T>> if T is not an atom
                 // or if T is a primitive.
                 // Code for primitives is already generated
@@ -77,7 +77,7 @@ pub fn bridge(namespace: &Namespace, ffi: ItemMod) -> Result<TokenStream> {
                     }
                 }
             }
-        } else if let Type::Vector(ptr) = ty {
+        } else if let Type::CxxVector(ptr) = ty {
             if let Type::Ident(ident) = &ptr.inner {
                 if Atom::from(ident).is_none() {
                     // Generate code for CxxVector<T> if T is not an atom
diff --git a/syntax/check.rs b/syntax/check.rs
index 387f9a6..cbfa91b 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -31,7 +31,7 @@ fn do_typecheck(cx: &mut Check) {
             Type::RustBox(ptr) => check_type_box(cx, ptr),
             Type::RustVec(ptr) => check_type_vec(cx, ptr),
             Type::UniquePtr(ptr) => check_type_unique_ptr(cx, ptr),
-            Type::Vector(ptr) => check_type_vector(cx, ptr),
+            Type::CxxVector(ptr) => check_type_vector(cx, ptr),
             Type::Ref(ty) => check_type_ref(cx, ty),
             Type::Slice(ty) => check_type_slice(cx, ty),
             _ => {}
@@ -114,7 +114,7 @@ fn check_type_unique_ptr(cx: &mut Check, ptr: &Ty1) {
             None | Some(CxxString) => return,
             _ => {}
         }
-    } else if let Type::Vector(_) = &ptr.inner {
+    } else if let Type::CxxVector(_) = &ptr.inner {
         return;
     }
 
@@ -351,7 +351,7 @@ fn describe(cx: &mut Check, ty: &Type) -> String {
         Type::UniquePtr(_) => "unique_ptr".to_owned(),
         Type::Ref(_) => "reference".to_owned(),
         Type::Str(_) => "&str".to_owned(),
-        Type::Vector(_) => "vector".to_owned(),
+        Type::CxxVector(_) => "vector".to_owned(),
         Type::Slice(_) => "slice".to_owned(),
         Type::SliceRefU8(_) => "&[u8]".to_owned(),
         Type::Fn(_) => "function pointer".to_owned(),
diff --git a/syntax/impls.rs b/syntax/impls.rs
index 8e94f06..c34e3e5 100644
--- a/syntax/impls.rs
+++ b/syntax/impls.rs
@@ -27,7 +27,7 @@ impl Hash for Type {
             Type::Ref(t) => t.hash(state),
             Type::Str(t) => t.hash(state),
             Type::RustVec(t) => t.hash(state),
-            Type::Vector(t) => t.hash(state),
+            Type::CxxVector(t) => t.hash(state),
             Type::Fn(t) => t.hash(state),
             Type::Slice(t) => t.hash(state),
             Type::SliceRefU8(t) => t.hash(state),
@@ -47,7 +47,7 @@ impl PartialEq for Type {
             (Type::Ref(lhs), Type::Ref(rhs)) => lhs == rhs,
             (Type::Str(lhs), Type::Str(rhs)) => lhs == rhs,
             (Type::RustVec(lhs), Type::RustVec(rhs)) => lhs == rhs,
-            (Type::Vector(lhs), Type::Vector(rhs)) => lhs == rhs,
+            (Type::CxxVector(lhs), Type::CxxVector(rhs)) => lhs == rhs,
             (Type::Fn(lhs), Type::Fn(rhs)) => lhs == rhs,
             (Type::Slice(lhs), Type::Slice(rhs)) => lhs == rhs,
             (Type::SliceRefU8(lhs), Type::SliceRefU8(rhs)) => lhs == rhs,
diff --git a/syntax/mangled.rs b/syntax/mangled.rs
index 56e8b73..2a2fa4c 100644
--- a/syntax/mangled.rs
+++ b/syntax/mangled.rs
@@ -23,7 +23,7 @@ impl ToMangled for Type {
             Type::RustBox(ptr) => format!("rust_box${}", ptr.inner.to_mangled(namespace)),
             Type::RustVec(ptr) => format!("rust_vec${}", ptr.inner.to_mangled(namespace)),
             Type::UniquePtr(ptr) => format!("std$unique_ptr${}", ptr.inner.to_mangled(namespace)),
-            Type::Vector(ptr) => format!("std$vector${}", ptr.inner.to_mangled(namespace)),
+            Type::CxxVector(ptr) => format!("std$vector${}", ptr.inner.to_mangled(namespace)),
             _ => unimplemented!(),
         }
     }
diff --git a/syntax/mod.rs b/syntax/mod.rs
index 4e0b908..c992690 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -92,7 +92,7 @@ pub enum Type {
     UniquePtr(Box<Ty1>),
     Ref(Box<Ref>),
     Str(Box<Ref>),
-    Vector(Box<Ty1>),
+    CxxVector(Box<Ty1>),
     Fn(Box<Signature>),
     Void(Span),
     Slice(Box<Slice>),
diff --git a/syntax/parse.rs b/syntax/parse.rs
index f5c598d..f32894b 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -303,7 +303,7 @@ fn parse_type_path(ty: &TypePath) -> Result<Type> {
                 } else if ident == "Vector" && generic.args.len() == 1 {
                     if let GenericArgument::Type(arg) = &generic.args[0] {
                         let inner = parse_type(arg)?;
-                        return Ok(Type::Vector(Box::new(Ty1 {
+                        return Ok(Type::CxxVector(Box::new(Ty1 {
                             name: ident,
                             langle: generic.lt_token,
                             inner,
diff --git a/syntax/tokens.rs b/syntax/tokens.rs
index 3d67a0a..7423f8e 100644
--- a/syntax/tokens.rs
+++ b/syntax/tokens.rs
@@ -14,7 +14,7 @@ impl ToTokens for Type {
                 }
                 ident.to_tokens(tokens);
             }
-            Type::RustBox(ty) | Type::UniquePtr(ty) | Type::Vector(ty) | Type::RustVec(ty) => {
+            Type::RustBox(ty) | Type::UniquePtr(ty) | Type::CxxVector(ty) | Type::RustVec(ty) => {
                 ty.to_tokens(tokens)
             }
             Type::Ref(r) | Type::Str(r) | Type::SliceRefU8(r) => r.to_tokens(tokens),
diff --git a/syntax/typename.rs b/syntax/typename.rs
index 7ad1be2..016749a 100644
--- a/syntax/typename.rs
+++ b/syntax/typename.rs
@@ -29,7 +29,7 @@ impl ToTypename for Type {
             Type::UniquePtr(ptr) => {
                 format!("::std::unique_ptr<{}>", ptr.inner.to_typename(namespace))
             }
-            Type::Vector(ptr) => format!("::std::vector<{}>", ptr.inner.to_typename(namespace)),
+            Type::CxxVector(ptr) => format!("::std::vector<{}>", ptr.inner.to_typename(namespace)),
             _ => unimplemented!(),
         }
     }
diff --git a/syntax/types.rs b/syntax/types.rs
index 7bce154..2ef1e1e 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -24,9 +24,10 @@ impl<'a> Types<'a> {
             all.insert(ty);
             match ty {
                 Type::Ident(_) | Type::Str(_) | Type::Void(_) | Type::SliceRefU8(_) => {}
-                Type::RustBox(ty) | Type::UniquePtr(ty) | Type::Vector(ty) | Type::RustVec(ty) => {
-                    visit(all, &ty.inner)
-                }
+                Type::RustBox(ty)
+                | Type::UniquePtr(ty)
+                | Type::CxxVector(ty)
+                | Type::RustVec(ty) => visit(all, &ty.inner),
                 Type::Ref(r) => visit(all, &r.inner),
                 Type::Slice(s) => visit(all, &s.inner),
                 Type::Fn(f) => {

